#ifndef __TSYNC_DRIVER_HELPERS__
#define __TSYNC_DRIVER_HELPERS__ 1

#include <asm/delay.h>
#include <asm/uaccess.h>

#include <linux/ioport.h>
#include <linux/version.h>

#include "ddtpro.h"
#include "tsyncpci.h"

#include <linux/types.h>
#include <asm/byteorder.h>

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,16)
#include <asm/io.h>
#else
#include <linux/io.h>
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,24)
typedef unsigned long       uintptr_t;
#endif

#define BIG_END_16(value) __be16_to_cpu(value)
#define BIG_END_32(value) __be32_to_cpu(value)
#define BIG_END_64(value) __be64_to_cpu(value)

typedef tsyncpci_dev_t TPRO_INSTANCE_T;

#define TSYNC_READ_REG(offset) (ioread16((void*)hw->ioAddr + (offset)))
#define TSYNC_WRITE_REG(value, offset) (iowrite16((value), (void*)hw->ioAddr + (offset)))

#define TSYNC_COPY_FROM_IO(destination, offset, words)                      \
{                                                                           \
    uint32_t iii;                                                           \
    uint16_t ooo = offset;                                                  \
                                                                            \
    for (iii = 0; iii < words; iii++)                                       \
    {                                                                       \
        ((uint16_t*)destination)[iii] = TSYNC_READ_REG(ooo);                \
        ooo += sizeof(uint16_t);                                            \
    }                                                                       \
}

#define TSYNC_COPY_FROM_IO32(destination, offset, words) memcpy_fromio((destination), (void*)hw->ioAddr + (offset), (words) * sizeof(uint16_t));                     \

#define BUSY_WAIT(microseconds) udelay(microseconds)

#define SRC_LOCATION_FORMAT_STRING "(%s:%u)\n"
#define SRC_LOCATION_VARIABLES __FILE__, __LINE__
#endif
