#ifndef __tsync_types__
#define __tsync_types__ 1

typedef enum {
    tsync_super_second_offset = 0x000,
    tsync_nano_sub_second_offset = 0x008,
    tsync_super_second_binary_offset = 0x00c,
    
    tsync_gpio_output_0_high_match_offset = 0x040,
    tsync_gpio_output_0_low_match_offset = 0x050,
    tsync_gpio_output_1_high_match_offset = 0x060,
    tsync_gpio_output_1_low_match_offset = 0x070,
    tsync_gpio_output_2_high_match_offset = 0x080,
    tsync_gpio_output_2_low_match_offset = 0x090,
    tsync_gpio_output_3_high_match_offset = 0x0A0,
    tsync_gpio_output_3_low_match_offset = 0x0B0,
    
    tsync_timestamp_status_offset = 0x020,
    tsync_timestamp_fifo_offset = 0x022,

    tsync_fpga_status_offset = 0x0C0,
    tsync_fpga_revision_id_offset = 0x0C2,

    tsync_interrupt_mask_offset = 0x0C4,
    tsync_interrupt_status_offset = 0x0C6,

    tsync_fifo_status_offset = 0x160,
    tsync_fifo_transmit_offset = 0x180,
    tsync_fifo_receive_offset = 0x1C0,

/*** Start of non-kts entry area [DO NOT MOVE OR ALTER THIS LINE] ***/

/*** End of non-kts entry area [DO NOT MOVE OR ALTER THIS LINE] ***/

} tsync_register_offsets;

#define MAX_TRANSACTION_BUFFER_WORDS 1280
#define MAX_HW_REQUEST_LENGTH 1280
#define MAX_HW_RESPONSE_LENGTH (16*1280)

#define TSYNC_INTERRUPT_COUNT 15

#endif
